From db388c909028976f562e13d50e087d0738908482 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 27 2020 20:43:48 +0000
Subject: [PATCH 1808/2232] Update Slice iterator definition to follow canonical signatures


---

diff --git a/include/cxx.h b/include/cxx.h
index c1d452e..d1c87c8 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -188,8 +188,8 @@ public:
   using reference = typename std::add_lvalue_reference<T>::type;
   using iterator_category = std::forward_iterator_tag;
 
-  T &operator*() const noexcept;
-  T *operator->() const noexcept;
+  reference operator*() const noexcept;
+  pointer operator->() const noexcept;
   iterator &operator++() noexcept;
   iterator operator++(int) noexcept;
   bool operator==(const iterator &) const noexcept;
@@ -557,12 +557,14 @@ T &Slice<T>::back() const noexcept {
 }
 
 template <typename T>
-T &Slice<T>::iterator::operator*() const noexcept {
+typename Slice<T>::iterator::reference
+Slice<T>::iterator::operator*() const noexcept {
   return *this->pos;
 }
 
 template <typename T>
-T *Slice<T>::iterator::operator->() const noexcept {
+typename Slice<T>::iterator::pointer
+Slice<T>::iterator::operator->() const noexcept {
   return this->pos;
 }
 

